------------------------------------------------------------------
-- PROJECT:     HiCoVec Processor
--
-- ENTITY:	CFG
--
-- PURPOSE:	Configuration-File
-- 
-- 
-- Created by: Harald Manske
--
-- Prof. Gundolf Kiefer
-- Hochschule Augsburg
--
-- 
--
-- 
-- DATE CREATE: 
-- LAST CHANGE: 2008-11-24 FROM: Andreas Mueller
-- VERSION:     0.1
-----------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package cfg_hicovec is
-- HiCoVec Configuration

	constant n: integer := 16;                      -- amount of vector registers 
	constant k: integer := 16;                     	-- amount words per vector register (even numbers)

	constant use_scalar_mult : boolean := true;     -- allow multiplications in scalar alu
	constant use_vector_mult : boolean := true;    -- allow multiplications in vector alu

	constant use_shuffle : boolean := false;        -- use shuffle unit
	constant max_shuffle_width : integer := 0;      -- max. shuffle width (dividable by 4)

	constant use_vectorshift : boolean := true;     -- allow shift of vector registers (vmol, vmor)
	constant vectorshift_width : integer := 4;     -- width of vectorshift in bit

end cfg_hicovec;
