------------------------------------------------------------------
-- PROJECT:     Der Hicovec Prozessor in Aktion
--
-- ENTITY:      DB_MULTIPLEXER
--
-- PURPOSE:	Tristate for DB
-- 
-- System to
-- Connect,
-- Operate ,
-- Transfer data and
-- Compute with the
-- Hicovec 
--
-- TEAM:
--
-- Jakob Golus
-- David Lucinkiewicz
-- Andreas Mueller
-- Florian Richter	
-- Sebastian Rigorth
-- Soeren Ruehm
--
-- 
-- DATE: 2008-12-28
-- VERSION:     0.1
-----------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity db_multiplexer is
	port (
		wr: in std_logic;
		d_in: out std_logic_vector(31 downto 0);
		d_out: in std_logic_vector(31 downto 0);
		data: inout std_logic_vector(31 downto 0)
	);
end db_multiplexer;
architecture rtl of db_multiplexer is  
begin
	process (d_out, wr)
	begin
		if wr = '1' then
			data <= d_out;
		else
			data <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
		end if;
	end process;
	d_in <= data;
end rtl;

