struct cons {
  struct cons *car;             /* Left Element */
  struct cons *cdr;             /* Right Element */
};

struct cons CONSES[100];        /* Object Pool */
struct cons NIL = {0, 0};       /* End of List */
static int alloc_offset = 0;    /* Offset in Pool */

/* Get a new Cell */
struct cons* new_cons(){
  return &(CONSES[alloc_offset++]);
}

/* New Cell with (Car . Cdr) */
struct cons *cons(struct cons *car, struct cons *cdr){
  struct cons *c = new_cons();
  c->car = car;
  c->cdr = cdr;
  return c;
}

int main(void){
  struct cons *c = &NIL;
  struct cons *iter;
  int i;
  int a = 1;
  /* Build a List (1..10) */
  for (i = 1; i <= 10; i++){
    c = cons((struct cons *) i, c);
  }
  /* Reduce it with * aka factorial */
  for (iter = c; iter != &NIL; iter = iter->cdr){
    a *= (int) iter->car;
  }
  return a == 3628800;
}

