
/*****************************************************************************/
/* HEADER INCLUDES							     */
/*****************************************************************************/

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"
#include "conditions.h"
#include "output.h"
#include "insn-codes.h"
#include "insn-attr.h"
#include "flags.h"
#include "except.h"
#include "function.h"
#include "recog.h"
#include "expr.h"
#include "optabs.h"
#include "toplev.h"
#include "basic-block.h"
#include "target.h"
#include "target-def.h"


#include "hicovec.h"
int hicovec_hard_regno_mode_ok (int regno, enum machine_mode mode);
enum reg_class hicovec_reg_class_from_constraint(char p);
void hicovec_asm_function_prologue(FILE *file, HOST_WIDE_INT size);
enum reg_class hicovec_regno_reg_class (int);
void hicovec_notice_update_cc (rtx exp, rtx insn);
enum reg_class hicovec_secondary_reload (bool IN_P, rtx x, enum reg_class RELOAD_CLASS, enum machine_mode RELOAD_MODE, secondary_reload_info *SRI);
int hicovec_legitimate_address_p (int ATTRIBUTE_UNUSED, rtx, int);
int hicovec_legitimate_constant_p (int ATTRIBUTE_UNUSED, rtx, int);
void hicovec_print_operand (FILE * file, rtx x, int code);
void hicovec_print_operand_address (FILE * file, rtx addr);
bool hicovec_float_supported_p(void);
bool hicovec_fixed_point_supported_p(void);
bool hicovec_output_integer(rtx x, unsigned int size, int aligned_p);

/* Initialize the GCC target structure.  */

#undef  TARGET_ASM_FUNCTION_PROLOGUE
#define TARGET_ASM_FUNCTION_PROLOGUE hicovec_asm_function_prologue
#undef TARGET_SECONDARY_RELOAD
#define TARGET_SECONDARY_RELOAD hicovec_secondary_reload

#undef TARGET_ASM_BYTE_OP
#define TARGET_ASM_BYTE_OP         "\t.dc\t"
#undef TARGET_ASM_ALIGNED_HI_OP


#define TARGET_ASM_ALIGNED_HI_OP   "\t.dc\t"
#undef TARGET_ASM_ALIGNED_DI_OP
#define TARGET_ASM_ALIGNED_DI_OP   "\t.dc\t"
#undef TARGET_ASM_ALIGNED_TI_OP    
#define TARGET_ASM_ALIGNED_TI_OP   "\t.dc\t"
#undef TARGET_ASM_UNALIGNED_HI_OP  
#define TARGET_ASM_UNALIGNED_HI_OP "\t.dc\t"
#undef TARGET_ASM_UNALIGNED_DI_OP  
#define TARGET_ASM_UNALIGNED_DI_OP "\t.dc\t"
#undef TARGET_ASM_UNALIGNED_TI_OP  
#define TARGET_ASM_UNALIGNED_TI_OP "\t.dc\t"
#undef TARGET_ASM_UNALIGNED_SI_OP  
#define TARGET_ASM_UNALIGNED_SI_OP "\t.dc\t"
#undef TARGET_ASM_INTEGER
#define TARGET_ASM_INTEGER hicovec_output_integer


/* #undef TARGET_ASM_FILE_END */




/* #define TARGET_ASM_FILE_END fputs(asm_out_file, "\n.end\n")          */

struct gcc_target targetm = TARGET_INITIALIZER;


bool hicovec_float_supported_p(void)
{
  return false;
}

bool hicovec_fixed_point_supported_p(void)
{
  return false;
}

bool hicovec_output_integer(rtx x, unsigned int size, int aligned_p){
  fputs ("\t.dc ", asm_out_file);
  output_addr_const (asm_out_file, x);
  fputs ("\n", asm_out_file);
  return true;
}



/* Returns the additional needed register class (if any) for a mov */
enum reg_class hicovec_secondary_reload (bool in_p, rtx x, enum reg_class reload_class, enum machine_mode mode, secondary_reload_info *SRI)
{
  if (MEM_P (x) && (reload_class != GENERAL_REGS) && ! in_p )
    return GENERAL_REGS;
  /* For supporting Floating Point, bigger constants than 16 bit are needed. Support might be added here */
  return NO_REGS;
}

/* REGISTER USAGE */
/* -------------- */

/* Return the class number of the smallest class containing reg number REGNO. */
enum reg_class hicovec_regno_reg_class (int regno)
{
  switch(regno){
  case 0:
    return GENERAL_REGS;
  case 1: 
  case 2:
    return ARITH_REGS;
  case 3:
    return SP_REGS;
  default:
    return NO_REGS;
  }
}

/* All Registers can take a 32 Bit Value */
int hicovec_hard_regno_mode_ok (int regno, enum machine_mode mode)
{
  if(regno<2)
    return 1;
    
  return 0;
}

/* Code taken from avr */
/* Sets cc_status to the rtx that most recently changed the flags and
   marks which of those are not usable. Since all INSNs are tagged, this is easy */
void hicovec_notice_update_cc (rtx exp, rtx insn)
{
  rtx set;
  switch (get_attr_cc (insn)){
  case CC_NONE:
    break;
  case CC_SET_Z:
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	{
	  cc_status.flags |= CC_NO_OVERFLOW;
	  cc_status.value1 = SET_DEST (set);
	}
    break;
  case CC_SET_CZ:
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	{
	  cc_status.value1 = SET_DEST (set);
	}
      break;
    break;
  case CC_COMPARE:
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	cc_status.value1 = SET_SRC (set);
      break;
    break;
  case CC_CLOBBER:
    CC_STATUS_INIT;
    break;
  }
}

/* Destructures and prints a single operand */
void hicovec_print_operand (FILE * file, rtx x, int code)
{ 
 retry:
  switch (GET_CODE(x))
    {
    case MEM:
      x = XEXP (x, 0);
      goto retry;

    case CONST_INT:
      fprintf (file, "%li", INTVAL(x));
      return;
    case LABEL_REF:
      fprintf(file,"0 + %s",LABEL_NAME(x));      
      return;

    case REG:
      switch (REGNO(x))
  	{
  	case 0:
          fprintf (file, "A");
          return;
  	case 1:
          fprintf (file, "X");
          return;
  	case 2:
          fprintf (file, "Y");
          return;  	
  	}
    case SYMBOL_REF:
      output_addr_const (file,x);
      return;
    default:
      sorry("Unrecognized Operand");
    }
}

void hicovec_print_operand_address (FILE * file, rtx addr)
{
  rtx base = NULL_RTX, index = NULL_RTX;
  enum rtx_code addr_code;
 
 retry:
 
  addr_code = GET_CODE (addr);
 
  switch (addr_code)
    {
    case MEM:
      addr = XEXP (addr, 0);
      goto retry;
      
      /*case CONST:*/
    case CONST_INT:
        fprintf(file,"[0 + %li]", INTVAL(addr));
      break;
      

      /*case SYMBOL_REF:*/
    case LABEL_REF:
      fprintf(file,"[0 + %s]",LABEL_NAME(addr));      
      break;

    case REG:                   
      index = addr;
      base = const0_rtx;
      fprintf(file, "[0 + ");
      hicovec_print_operand(file,index,0);
      fprintf(file, "]");
      break;

    case PLUS:
      fprintf(file, "[");
      base = XEXP(addr, 0);
      index = XEXP(addr, 1);
      if (REG_P(base))
        hicovec_print_operand(file, base, 0);
      else
        fprintf(file, "0");
        
      fprintf(file, " + ");
        	
      if (REG_P(index))
        hicovec_print_operand(file, index, 0);
      else if (GET_CODE(index) == CONST_INT)
        fprintf(file, "%li", INTVAL(index));        
      else
        fprintf(file, "%s", LABEL_NAME(index));
      fprintf(file, "]");
      break;

    default:
      fprintf(file, "[0 + ");
      output_addr_const(file, addr);
      fprintf(file, "]");
    }

}

enum reg_class hicovec_reg_class_from_constraint(char p)
{
  switch(p)
    {
    case 'a': return ARITH_REGS;
    case 'R': return SP_REGS;
    default: return NO_REGS;
    }  
}

/* Returns 1 if the address can be understood. Includes things like [A + -20] */
int hicovec_legitimate_address_p (int unused, rtx addr, int strict)
{
  rtx base = NULL_RTX, index = NULL_RTX;
  int base_valid = 0;
  int index_valid = 0;
  int all_valid = 0;

  switch (GET_CODE (addr))
    {
    case CONST_INT:
        all_valid = 1;
      break;
      
    case SYMBOL_REF:
    case LABEL_REF:
      all_valid = 1;
      break;

    case REG:                   /* Use the Register as index as the assembler might be able to squeeze a vector op in here */
      index = addr;
      base = const0_rtx;
      base_valid = 1;
      index_valid = 1;
      break;

    case PLUS:
      base = XEXP(addr, 0);
      index = XEXP(addr, 1);
      if (REG_P(base) || (GET_CODE(base) == CONST_INT && INTVAL(base) == 0))
        base_valid = 1;
      if (REG_P(index) || (GET_CODE(index) == CONST_INT))
        index_valid = 1;
      break;

    default:
      return FALSE;
    }

  if (strict && base_valid && index_valid)
    {
      if (!CONSTANT_ADDRESS_P (base))
        if(REG_P(base))
          if (!REGNO_OK_FOR_BASE_P (REGNO (base)))
            return FALSE;
	     
      if (!CONSTANT_ADDRESS_P (index))
        if(REG_P(index))
          if (!REGNO_OK_FOR_INDEX_P (REGNO (index)))
            return FALSE;
    }
  if (all_valid || (base_valid && index_valid))
    return TRUE;
  else
    return FALSE;
}

/* Dynamic, as it allocates local vars */
void hicovec_asm_function_prologue(FILE *file, HOST_WIDE_INT size)
{
  asm_fprintf(file,"\tmov X, r0(0)\n");
  asm_fprintf(file,"\tst [X + -4], A\t;store retp\n");
  asm_fprintf(file,"\tor A, Y, Y\n");
  asm_fprintf(file,"\tst [X + -8], A\t;store old bp\n");
  asm_fprintf(file,"\tsub Y, X, 8 \t;bp = sp\n");
  asm_fprintf(file,"\tsub X, X, %li\t;8 for retp and old bp, %li allocated for local vars\n", size + 8, size);
  asm_fprintf(file,"\tmov r0(0), X\t;write sp back\n\n");
}


const char * ret_cond_branch (rtx x, int reverse){
  RTX_CODE cond = reverse ? reverse_condition (GET_CODE (x)) : GET_CODE (x);
  switch (cond){
  case GE:
  case GEU:
      return "jc %a0";
  case LT:
  case LTU:
      return "jnc %a0";
  case LE:
  case LEU:
    return "jz %a0\n\tjnc %a0"; /* Check if equal, then Less Than */
  case GT:
  case GTU:                     /* Look at the picture. It's complicated. Basically the same pattern as the AVR, but with faked relative branches*/
    return "st [0 + __retp_libc], A\n"
      "\tjal A, [0 + __ret_pc]\n"
      "\tjc [0 + __skip_2]\n"
      "\tjal A, [0 + __skip_3]\n"
      "\tjz [0 + __skip_5]\n"
      "\tld A, [0 + __retp_libc]\n"
      "\tjmp %a0\n"
      "\tld A, [0 + __retp_libc]\n";
  default:
    sorry("Branch Pattern broken");
  }
}
