        .org 0x00
        .start
;.globl _start
_start:
        or X, 0, 0
        sec
        ror X, X
        sub X, X, 4             ;HiCoSim Display looks ugly on 0x80000000
        or Y, X, X
        mov r0(0), X
        jal A, [0 + main]
        halt

__main:
        jmp [0 + A]

__ret_pc:
        jmp [0 + A]

__retp_libc:    .dc 0
__bp_libc:      .dc 0
        ;; .global __mulsi3
__mulsi3:
        st [0 + __retp_libc], A
        or A, Y, Y
        st [0 + __bp_libc], A
        mov X, r0(0)
        ld A, [X + 4]
        ld X, [X + 0]
        xor Y, Y, Y
__mul_loop:
        and 0, A, 1
        jz [0 + __mul_skip]
        add Y, Y, X
__mul_skip:       
        lsl X, X
        lsr A, A
        jnz [0 + __mul_loop]
        or A, Y, Y
        ld Y, [0 + __bp_libc]
        ld X, [0 + __retp_libc]
        jmp [0 + X]

__ashlsi3:
        jmp [0 + __lshlsi3]
        
__ashrsi3:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 8	;8 for retp and old bp, 0 allocated for local vars
	mov r0(0), X	;write sp back

	ld A, [Y + 8]	; A = [Y + 8]
	sub 0, A, 0	; A != 0?
	jc [0 + __ashrsi3_LL2]
	sub A, 0, A	; A = -A
__ashrsi3_LL2:
	mov X, r0(0)	; X = SP
	add X, X, -8	; X = X + -8
	mov r0(0), X	; SP = X
	st [0 + X], A	; [0 + X] = A
	ld A, [Y + 12]	; A = [Y + 12]
	st [X + 4], A	; [X + 4] = A
	jal A, [0 + __lshrsi3]	; A = call [0 + __lshrsi3]
	mov X, r0(0)	; X = SP
	add X, X, 8	; X = X + 8
	mov r0(0), X	; SP = X
	ld X, [Y + 8]	; X = [Y + 8]
	sub 0, X, 0	; X != 0?
	jc [0 + __ashrsi3_LL3]
	sub 0, A, 0	; A != 0?
	jnz [0 + __ashrsi3_LL4]
	or A, 0, -1	; A = -1
	jmp [0 + __ashrsi3_LL3]
__ashrsi3_LL4:
	sub A, 0, A	; A = -A
__ashrsi3_LL3:
	jmp [0 + __fun_epilogue]	

;; __lshrsi3:
;;         st [0 + __retp_libc], A
;;         mov X, r0(0)
;;         ld A, [X + 0]
;;         ld X, [X + 4]
;;         sub 0, X, 0
;;         jz [0 + __lshrsi3_end]
;;         sub 0, X, 32
;;         jnc [0 + __lshrsi3_loop] ;Cap on 32
;;         or X, 0, 32
;; __lshrsi3_loop: 
;;         lsr A, A
;;         dec X, X
;;         jnz [0 + __lshrsi3_loop]
;; __lshrsi3_end:
;;         ld X, [0 + __retp_libc]
;;         jmp [0 + X]
        

;; __lshlsi3:
;;         st [0 + __retp_libc], A
;;         mov X, r0(0)
;;         ld A, [X + 0]
;;         ld X, [X + 4]
;;         sub 0, X, 0
;;         jz [0 + __lshlsi3_end]
;;         sub 0, X, 32
;;         jnc [0 + __lshlsi3_loop] ;Cap on 32
;;         or X, 0, 32
;; __lshlsi3_loop: 
;;         lsl A, A
;;         dec X, X
;;         jnz [0 + __lshlsi3_loop]
;; __lshlsi3_end:
;;         ld X, [0 + __retp_libc]
;;         jmp [0 + X]

        ;; The unrolled loops for shifts are faster on shifts >= 3, slightly slower below. Use the unrolled ones
        
__lshlsi3:
        st [0 + __retp_libc], A
        or A, Y, Y
        st [0 + __bp_libc], A
        mov X, r0(0)
        ld Y, [0 + X]
        ld X, [X + 4]           ; >> X
        and X, X, 31
        or A, 0, 33
        sub X, A, X
        jal A, [0 + __ret_pc]
        jmp [A + X]
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        lsl Y, Y
        or A, Y, Y
        ld Y, [0 + __bp_libc]
        ld X, [0 + __retp_libc]
        jmp [0 + X]


__lshrsi3:
        st [0 + __retp_libc], A
        or A, Y, Y
        st [0 + __bp_libc], A
        mov X, r0(0)
        ld Y, [0 + X]
        ld X, [X + 4]           ; >> X
        and X, X, 31
        or A, 0, 33
        sub X, A, X
        jal A, [0 + __ret_pc]
        jmp [A + X]
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        lsr Y, Y
        or A, Y, Y
        ld Y, [0 + __bp_libc]
        ld X, [0 + __retp_libc]
        jmp [0 + X]
        
        
        
        ;; RETURN

        
__skip_1:
        jmp [A + 1]
__skip_2:
        jmp [A + 2]
__skip_3:
        jmp [A + 3]
__skip_4:
        jmp [A + 4]
__skip_5:
        jmp [A + 5]

__fun_epilogue:                 ;Always the same, so can be done as Subroutine
        add X, Y, 8
	mov r0(0), X 
	ld X, [Y + 4]		;pop retp
	ld Y, [0 + Y]	      ;pop ebp
	jmp [0 + X]

        
        ;; Below generated from GCC - should automate this
        ;; This is unoptimized code. The optimizer breaks the routines right now.

udivmodsi4:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 32	;8 for retp and old bp, 24 allocated for local vars
	mov r0(0), X	;write sp back

	or A, 0, 1	; A = 1
	st [Y + -12], A	; [Y + -12] = A
	or A, 0, 0	; A = 0
	st [Y + -8], A	; [Y + -8] = A
	jmp [0 + div_LL2]
div_LL4:
	ld A, [Y + 12]	; A = [Y + 12]
	add A, A, A	; A = A + A
	st [Y + 12], A	; [Y + 12] = A
	ld A, [Y + -12]	; A = [Y + -12]
	add A, A, A	; A = A + A
	st [Y + -12], A	; [Y + -12] = A
div_LL2:
	ld X, [Y + 12]	; X = [Y + 12]
	or A, X, X	; A = X
	st [Y + -16], A	; [Y + -16] = A
	ld A, [Y + 8]	; A = [Y + 8]
	ld X, [Y + -16]	; X = [Y + -16]
	sub 0, X, A	; X < A?
	jc [0 + div_LL5]
	ld A, [Y + -12]	; A = [Y + -12]
	sub 0, A, 0	; A != 0?
	jz [0 + div_LL5]
	ld A, [Y + 12]	; A = [Y + 12]
	sub 0, A, 0	; A != 0?
	jc [0 + div_LL4]
	jmp [0 + div_LL5]
div_LL7:
	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -20], A	; [Y + -20] = A
	ld A, [Y + 12]	; A = [Y + 12]
	ld X, [Y + -20]	; X = [Y + -20]
	sub 0, X, A	; X < A?
	jnc [0 + div_LL6]
	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -24], A	; [Y + -24] = A
	ld A, [Y + 12]	; A = [Y + 12]
	ld X, [Y + -24]	; X = [Y + -24]
	sub X, X, A	; X = X - A
	or A, X, X	; A = X
	st [Y + 8], A	; [Y + 8] = A
	ld X, [Y + -8]	; X = [Y + -8]
	or A, X, X	; A = X
	st [Y + -28], A	; [Y + -28] = A
	ld A, [Y + -12]	; A = [Y + -12]
	ld X, [Y + -28]	; X = [Y + -28]
	or X, X, A	; X = X | A
	or A, X, X	; A = X
	st [Y + -8], A	; [Y + -8] = A
div_LL6:
	ld A, [Y + -12]	; A = [Y + -12]
;APP
;# 19 "divmod.c" 1
	lsr A, A
;# 0 "" 2
;NO_APP
	st [Y + -12], A	; [Y + -12] = A
	ld A, [Y + 12]	; A = [Y + 12]
;APP
;# 20 "divmod.c" 1
	lsr A, A
;# 0 "" 2
;NO_APP
	st [Y + 12], A	; [Y + 12] = A
div_LL5:
	ld A, [Y + -12]	; A = [Y + -12]
	sub 0, A, 0	; A != 0?
	jnz [0 + div_LL7]
	ld A, [Y + 16]	; A = [Y + 16]
	sub 0, A, 0	; A != 0?
	jz [0 + div_LL8]
	ld A, [Y + 8]	; A = [Y + 8]
	jmp [0 + div_LL9]
div_LL8:
	ld A, [Y + -8]	; A = [Y + -8]
div_LL9:
	jmp [0 + __fun_epilogue]

;	.globl	__divsi3
__divsi3:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 36	;8 for retp and old bp, 28 allocated for local vars
	mov r0(0), X	;write sp back

	or A, 0, 0	; A = 0
	st [Y + -12], A	; [Y + -12] = A
	ld A, [Y + 8]	; A = [Y + 8]
	sub 0, A, 0	; A != 0?
	jc [0 + div_LL12]
	ld A, [Y + 8]	; A = [Y + 8]
	sub A, 0, A	; A = -A
	st [Y + 8], A	; [Y + 8] = A
	or X, 0, 0	; X = 0
	or A, X, X	; A = X
	st [Y + -32], A	; [Y + -32] = A
	ld X, [Y + -12]	; X = [Y + -12]
	or A, X, X	; A = X
	st [Y + -24], A	; [Y + -24] = A
	ld A, [Y + -24]	; A = [Y + -24]
	sub 0, A, 0	; A != 0?
	jnz [0 + div_LL13]
	or X, 0, 1	; X = 1
	or A, X, X	; A = X
	st [Y + -32], A	; [Y + -32] = A
div_LL13:
	ld A, [Y + -32]	; A = [Y + -32]
	st [Y + -12], A	; [Y + -12] = A
div_LL12:
	ld A, [Y + 12]	; A = [Y + 12]
	sub 0, A, 0	; A != 0?
	jc [0 + div_LL14]
	ld A, [Y + 12]	; A = [Y + 12]
	sub A, 0, A	; A = -A
	st [Y + 12], A	; [Y + 12] = A
	or X, 0, 0	; X = 0
	or A, X, X	; A = X
	st [Y + -32], A	; [Y + -32] = A
	ld X, [Y + -12]	; X = [Y + -12]
	or A, X, X	; A = X
	st [Y + -28], A	; [Y + -28] = A
	ld A, [Y + -28]	; A = [Y + -28]
	sub 0, A, 0	; A != 0?
	jnz [0 + div_LL15]
	or X, 0, 1	; X = 1
	or A, X, X	; A = X
	st [Y + -32], A	; [Y + -32] = A
div_LL15:
	ld A, [Y + -32]	; A = [Y + -32]
	st [Y + -12], A	; [Y + -12] = A
div_LL14:
	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -20], A	; [Y + -20] = A
	ld X, [Y + 12]	; X = [Y + 12]
	or A, X, X	; A = X
	st [Y + -16], A	; [Y + -16] = A
	mov A, r0(0)	; A = SP
	add A, A, -12	; A = A + -12
	mov r0(0), A	; SP = A
	mov X, r0(0)	; X = SP
	or A, X, X	; A = X
	st [Y + -32], A	; [Y + -32] = A
	ld A, [Y + -20]	; A = [Y + -20]
	ld X, [Y + -32]	; X = [Y + -32]
	st [0 + X], A	; [0 + X] = A
	ld A, [Y + -16]	; A = [Y + -16]
	ld X, [Y + -32]	; X = [Y + -32]
	st [X + 4], A	; [X + 4] = A
	or A, 0, 0	; A = 0
	ld X, [Y + -32]	; X = [Y + -32]
	st [X + 8], A	; [X + 8] = A
	jal A, [0 + udivmodsi4]	; A = call [0 + udivmodsi4]
	mov X, r0(0)	; X = SP
	add X, X, 12	; X = X + 12
	mov r0(0), X	; SP = X
	st [Y + -8], A	; [Y + -8] = A
	ld A, [Y + -12]	; A = [Y + -12]
	sub 0, A, 0	; A != 0?
	jz [0 + div_LL16]
	ld A, [Y + -8]	; A = [Y + -8]
	sub A, 0, A	; A = -A
	st [Y + -8], A	; [Y + -8] = A
div_LL16:
	ld A, [Y + -8]	; A = [Y + -8]
	jmp [0 + __fun_epilogue]

;	.globl	__modsi3
__modsi3:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 28	;8 for retp and old bp, 20 allocated for local vars
	mov r0(0), X	;write sp back

	or A, 0, 0	; A = 0
	st [Y + -12], A	; [Y + -12] = A
	ld A, [Y + 8]	; A = [Y + 8]
	sub 0, A, 0	; A != 0?
	jc [0 + div_LL19]
	ld A, [Y + 8]	; A = [Y + 8]
	sub A, 0, A	; A = -A
	st [Y + 8], A	; [Y + 8] = A
	or A, 0, 1	; A = 1
	st [Y + -12], A	; [Y + -12] = A
div_LL19:
	ld A, [Y + 12]	; A = [Y + 12]
	sub 0, A, 0	; A != 0?
	jc [0 + div_LL20]
	ld A, [Y + 12]	; A = [Y + 12]
	sub A, 0, A	; A = -A
	st [Y + 12], A	; [Y + 12] = A
div_LL20:
	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -20], A	; [Y + -20] = A
	ld X, [Y + 12]	; X = [Y + 12]
	or A, X, X	; A = X
	st [Y + -16], A	; [Y + -16] = A
	mov A, r0(0)	; A = SP
	add A, A, -12	; A = A + -12
	mov r0(0), A	; SP = A
	mov X, r0(0)	; X = SP
	or A, X, X	; A = X
	st [Y + -24], A	; [Y + -24] = A
	ld A, [Y + -20]	; A = [Y + -20]
	ld X, [Y + -24]	; X = [Y + -24]
	st [0 + X], A	; [0 + X] = A
	ld A, [Y + -16]	; A = [Y + -16]
	ld X, [Y + -24]	; X = [Y + -24]
	st [X + 4], A	; [X + 4] = A
	or A, 0, 1	; A = 1
	ld X, [Y + -24]	; X = [Y + -24]
	st [X + 8], A	; [X + 8] = A
	jal A, [0 + udivmodsi4]	; A = call [0 + udivmodsi4]
	mov X, r0(0)	; X = SP
	add X, X, 12	; X = X + 12
	mov r0(0), X	; SP = X
	st [Y + -8], A	; [Y + -8] = A
	ld A, [Y + -12]	; A = [Y + -12]
	sub 0, A, 0	; A != 0?
	jz [0 + div_LL21]
	ld A, [Y + -8]	; A = [Y + -8]
	sub A, 0, A	; A = -A
	st [Y + -8], A	; [Y + -8] = A
div_LL21:
	ld A, [Y + -8]	; A = [Y + -8]
	jmp [0 + __fun_epilogue]

;	.globl	__udivsi3
__udivsi3:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 20	;8 for retp and old bp, 12 allocated for local vars
	mov r0(0), X	;write sp back

	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -12], A	; [Y + -12] = A
	ld X, [Y + 12]	; X = [Y + 12]
	or A, X, X	; A = X
	st [Y + -8], A	; [Y + -8] = A
	mov A, r0(0)	; A = SP
	add A, A, -12	; A = A + -12
	mov r0(0), A	; SP = A
	mov X, r0(0)	; X = SP
	or A, X, X	; A = X
	st [Y + -16], A	; [Y + -16] = A
	ld A, [Y + -12]	; A = [Y + -12]
	ld X, [Y + -16]	; X = [Y + -16]
	st [0 + X], A	; [0 + X] = A
	ld A, [Y + -8]	; A = [Y + -8]
	ld X, [Y + -16]	; X = [Y + -16]
	st [X + 4], A	; [X + 4] = A
	or A, 0, 0	; A = 0
	ld X, [Y + -16]	; X = [Y + -16]
	st [X + 8], A	; [X + 8] = A
	jal A, [0 + udivmodsi4]	; A = call [0 + udivmodsi4]
	mov X, r0(0)	; X = SP
	add X, X, 12	; X = X + 12
	mov r0(0), X	; SP = X
	jmp [0 + __fun_epilogue]

;	.globl	__umodsi3
__umodsi3:
	mov X, r0(0)
	st [X + -4], A	;store retp
	or A, Y, Y
	st [X + -8], A	;store old bp
	sub Y, X, 8 	;bp = sp
	sub X, X, 20	;8 for retp and old bp, 12 allocated for local vars
	mov r0(0), X	;write sp back

	ld X, [Y + 8]	; X = [Y + 8]
	or A, X, X	; A = X
	st [Y + -12], A	; [Y + -12] = A
	ld X, [Y + 12]	; X = [Y + 12]
	or A, X, X	; A = X
	st [Y + -8], A	; [Y + -8] = A
	mov A, r0(0)	; A = SP
	add A, A, -12	; A = A + -12
	mov r0(0), A	; SP = A
	mov X, r0(0)	; X = SP
	or A, X, X	; A = X
	st [Y + -16], A	; [Y + -16] = A
	ld A, [Y + -12]	; A = [Y + -12]
	ld X, [Y + -16]	; X = [Y + -16]
	st [0 + X], A	; [0 + X] = A
	ld A, [Y + -8]	; A = [Y + -8]
	ld X, [Y + -16]	; X = [Y + -16]
	st [X + 4], A	; [X + 4] = A
	or A, 0, 1	; A = 1
	ld X, [Y + -16]	; X = [Y + -16]
	st [X + 8], A	; [X + 8] = A
	jal A, [0 + udivmodsi4]	; A = call [0 + udivmodsi4]
	mov X, r0(0)	; X = SP
	add X, X, 12	; X = X + 12
	mov r0(0), X	; SP = X
	jmp [0 + __fun_epilogue]
