package hicosim.components.backend.io;

/** Enumeration for all HICOSIM Console-Input-Commands
 * @author Michael Wager 16th May 2009
 */
public enum Command {
	DUMMY("none", new Object[0]) {
	},
	EXIT("exit",  new Object[0]) {
	},
	HELP("help", new Object[0]) {
	},
	HELP_DELETEBR("help delete",  new Object[1]) {
	},
	HELP_BREAK("help break",  new Object[1]) {
	},
	HELP_WATCHPOINT("help watchpoint",  new Object[1]) {	
	},
	HELP_GET("help get",  new Object[1]) {
	},
	HELP_SET("help set",  new Object[1]) {
	},
	HELP_SETR("help setr",  new Object[1]) {
	},
	HELP_OPEN("help open",  new Object[1]) {
	},
	HELP_RESET("help reset",  new Object[1]) {
	},
	HELP_LIST("help list",  new Object[1]) {
	},
	HELP_INFO("help info", new Object[1]) {
	},
	HELP_CONFIG("help config",  new Object[1]) {
	},
	HELP_VGA("help vga",  new Object[1]) {
	},
	CLEAR("clear",  new Object[0]){
	},
	
	//------------
	
	LIST("list",  new Object[1]){ 
	},
	OPEN("open",  new Object[1]){ 
	},
	RUN("run", new Object[0]){
	},
	DELETE("delete",new Object[1]){
	},
	BREAKPOINT("break", new Object[1]){
	},
	WATCHPOINT("watch", new Object[1]){
	},
	STEP("step",  new Object[0]){
	},
	GET("get",  new Object[2]){
	},
	SET("set",  new Object[2]){
	},
	SETR("setr",  new Object[2]){ //set registers: setr A 5 : set content of A=5 or: set R0(i) 5 : set R0[i]=5
	},
	RESET("reset",  new Object[0]){
	},
	
	DISAS("disas",  new Object[0]){
	},
	
	CONFIG("config", new Object[2]){ 
	},
	
	INFO("info", new Object[1]){ 
	},
	
	/* edit Andi: Laden des TestPlugins */
	WATCHMEM("watchmem", new Object[2]){
	},
	
	BUTTONS("buttons", new Object[0]){
	},
	
	//MOEGLICHKEIT VGA VON KONSOLENAPP ZU STARTEN:
	VGA("vga", new Object[1]){ //1 param: start or end
	},
	
	;
	
	private String token;
	private Object[] params;
	
	//Get/Set-Methoden
	public String getToken() {
		return token;
	}
	public Object[] getParams() {
		return params;
	}
	public void setParams(Object[] params){
		this.params = params;
	}
	//Konstruktor
	private Command(String token, Object[] params) {
		this.token = token;
		this.params = params;
	};
}
