package hicosim.components.backend.processor;

import hicosim.components.plugins.IPlugin;

public interface IPluginManager {

	/* Plugin-Verwaltung! */
	public abstract void addPlugin(IPlugin newPlugin, int startAt, int endAt);

	/* Plugin kann sich selbst aus der Liste loeschen */
	public abstract void delPlugin(IPlugin oldPlugin);

	/* Mit dieser Methode koennen Plugins, die sich vorher beim speicher registriert haben, eine Addresse abfragen
	 */
	public abstract int pluginGetMemory(IPlugin plugin, int address)
			throws Exception;

	public abstract void pluginSetMemory(IPlugin plugin, int address, int value);

	/* Methode prueft, ob das Plugin schon im PluginManager registriert ist */
	public abstract boolean checkPlugin(IPlugin plugin);
	
	public void notifyPlugins(int adr, int value);
	
	public void reFreshPlugins();
	
	public void setNewRange(IPlugin plugin, int newStartAt, int newEndAt);

}