package hicosim.components.frontend;

import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;

import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.net.URL;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ToolBar extends JPanel
                         implements ActionListener {
    //protected JTextArea textArea;
    static final private String RUN = "run";
    static final private String STEP = "step";
    static final private String INTERRUPT = "interrupt";
    static final private String RESETALL = "reset all";
    static final private String RESETCPU = "reset cpu";
    static final private String RESETMEM = "reset memory";
    static final private String BREAKADD = "add breakpoint";
    static final private String BREAKREM = "remove breakpoint";
    static final private String BREAKREMALL = "remove all breakpoints";
    static final private String ASSEMBLE = "assemble";

    private final MainWindow mainWindow = null;

    public ToolBar() {
        super(new BorderLayout());

        //Create the toolbar.
        JToolBar toolBar = new JToolBar("Still draggable");
        addButtons(toolBar);

        /*
        //Create the text area used for output.  Request
        //enough space for 5 rows and 30 columns.
        textArea = new JTextArea(5, 30);
        textArea.setEditable(false);
        JScrollPane scrollPane = new JScrollPane(textArea);
		*/
        //Lay out the main panel.
        setPreferredSize(new Dimension(450, 130));
        add(toolBar, BorderLayout.PAGE_START);
        //add(scrollPane, BorderLayout.CENTER);

    }

    protected void addButtons(JToolBar toolBar) {
        JButton button = null;

        //start
        button = makeNavigationButton("start_3_small", RUN,
                                      "Run",
                                      "Run");
        toolBar.add(button);

        //step
        button = makeNavigationButton("continue_3_small", STEP,
                                      "Step",
                                      "Step");
        toolBar.add(button);

        //interrupt
        button = makeNavigationButton("interrupt_2_small", INTERRUPT,
                                      "Interrupt",
                                      "Interrupt");
        toolBar.add(button);

        //reset all
        button = makeNavigationButton("resetall_1_small", RESETALL,
                                      "Reset All",
                                      "Reset All");
        toolBar.add(button);

        //reset cpu
        button = makeNavigationButton("resetcpu_1_small", RESETCPU,
                                      "Reset CPU",
                                      "Reset CPU");
        toolBar.add(button);

        //reset memory
        button = makeNavigationButton("resetmem_1_small", RESETMEM,
                                      "Reset Memory",
                                      "Reset Memory");
        toolBar.add(button);

        //add breakpoint
        button = makeNavigationButton("breakpoint_1_small", BREAKADD,
                                      "Add Breakpoint",
                                      "Breakpoint");
        toolBar.add(button);

        //delete breakpoint
        button = makeNavigationButton("deletebreakpoint_1_small", BREAKREM,
                                      "Delete Breakpoint",
                                      "Delete Breakpoint");
        toolBar.add(button);

    	//delete all breakpoints
    	button = makeNavigationButton("deletebreakpointall_1_small", BREAKREMALL,
                                  	"Delete all Breakpoints",
                                  	"Delete all Breakpoints");
    	toolBar.add(button);

    	//assemble
    	button = makeNavigationButton("assemble_1_small", ASSEMBLE,
                                  	"Assemble",
                                  	"Assemble");
    	toolBar.add(button);

    }

    protected JButton makeNavigationButton(String imageName,
                                           String actionCommand,
                                           String toolTipText,
                                           String altText) {
        //Look for the image.
        String imgLocation = "icons/"
                             + imageName
                             + ".gif";
        URL imageURL = ToolBar.class.getResource(imgLocation);
        System.out.println(imageURL);

        //Create and initialize the button.
        JButton button = new JButton();
        button.setActionCommand(actionCommand);
        button.setToolTipText(toolTipText);
        button.addActionListener(this);

        if (imageURL != null) {                      //image found
            button.setIcon(new ImageIcon(imageURL, altText));
        } else {                                     //no image found
            button.setText(altText);
            System.err.println("Resource not found: "
                               + imgLocation);
        }

        return button;
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        String description = null;

        // Handle each button.
        if (RUN.equals(cmd)) { //first button clicked
            description = "run.";
        } else if (STEP.equals(cmd)) { // second button clicked
        	description = "step.";
        } else if (INTERRUPT.equals(cmd)) { // third button clicked
        	description = "interrupt.";
        } else if (RESETALL.equals(cmd)) { // third button clicked
        	description = "reset all.";
        } else if (RESETCPU.equals(cmd)) { // third button clicked
        	description = "reset cpu";;
        } else if (RESETMEM.equals(cmd)) { // third button clicked
        	description = "reset mem.";
        } else if (BREAKADD.equals(cmd)) { // third button clicked
        	description = "add breakpoint.";
        } else if (BREAKREM.equals(cmd)) { // third button clicked
        	description = "remove breakpoint.";
        }

        //displayResult(description);
    }

   /*
    protected void displayResult(String actionDescription) {
        textArea.append(actionDescription + newline);
        textArea.setCaretPosition(textArea.getDocument().getLength());
    }
*/

/*

     // Create the GUI and show it.  For thread safety,
     // this method should be invoked from the
     // event dispatch thread.

    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("ToolBarDemo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        frame.add(new ToolBar());

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                //Turn off metal's use of bold fonts
	        UIManager.put("swing.boldMetal", Boolean.FALSE);
	        createAndShowGUI();
            }
        });
    }
    */
}
