package hicosim.components.frontend.tablecellrenderers;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.table.TableCellRenderer;

/**
 * This class extends the super class JTextArea and implements the abstract
 * interface TableCellRenderer. This is needed in order to be able to change the
 * the background color of JTable cells. In order to use this feature the JTable
 * must invoke the method setDefaultRenderer(...) as followed:
 * setDefaultRenderer(Object.class, new
 * ColoredTableCellRendererScalarCpuRegisterOverview())
 *
 * @author Daniel Obermueller 18th June 2009
 *
 */
public class ColoredTableCellRendererScalarCpuRegisterOverview extends
		JTextArea implements TableCellRenderer {

	private static final long serialVersionUID = 1L;

	/**
	 * This method is used to set different background colors of JTable cells.
	 *
	 *
	 * @param JTable
	 *            table
	 * @param Object
	 *            value
	 * @param boolean
	 *            isSelected
	 * @param boolean
	 *            hasFocus
	 * @param int
	 *            row
	 * @param int
	 *            column
	 * @return Component
	 * @author Daniel Obermueller 18th June 2009
	 */
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		if (row == 0)
			setBackground(new Color(0xffeeeeee));
		else
			setBackground(Color.WHITE);
		setText(value.toString());
		return this;
	}
}
