package hicosim.control.utils;

/**
 * Interface IStatisticObserver - this interface has to be implemented by
 * any observing-classes.
 * 
 * @autor Weber
 */
public interface IStatisticObserver {

	
	/**
	 * updateStatsComands - This method is invoked on every comand
	 * execution. The observers will only get the current executed comand as a
	 * String, so the implementation and the view must be done by the observers.
	 * 
	 * @param comand (String, e.g. "ADD")
	 * @param type (String, e.g. "SKALARALU")
	 */
	public void updateStatsObserver(String comand, String type);

	
	/**
	 * resetStats - Resets the current stats. Method is invoked on resetting the
	 * processor. Previously the statistics are set to zero (types) or the whole map
	 * is deleted (comands). Within the resetStats-method every observer has to
	 * ensure that the representation is also updated.
	 *
	 */
	public void resetStats();
	
}
