/**
 * 
 */
package hicosim.control.utils;

/**
 * Class which holds all Messages for the user such as help,
 * version or aboutmessage.
 * 
 * @author Wager
 *
 */
public class Messages {
	
	public static final String version = "1.0";
	
	public static final String initialMessage = 
		"\nHICOSIM - Simulator for the HiCoVec Processor. v:"+version +" (c) 2009\n\n"					  
		+"Sebastian Minning\n"+"Daniel Obermueller\n"+"Michael Wager\n"
		+"Luca Calchera\n" + "Andreas Weber\n" + "Muege Oezugur\n" + "Hibetoullah Ftima\n"
		+"\nUniversity of Applied Sciences Augsburg\n\n";

	public static String getAboutMessage() {
		String about ="HICOSIM version 1.0 (c) 2009 \n\n"+
				"Sebastian Minning\n"+
				"Daniel Obermueller\n"+
				"Michael Wager\n"+
				"Luca Calchera\n"+
				"Andreas Weber\n"+
				"Muege Oezugur\n"+
				"Hibetoullah Ftima\n\n"+

				"University of Applied Sciences Augsburg\n\n"+
				
				"This program is free software; you can redistribute it and/or modify\n"+
				"it under the terms of the GNU General Public License as published\n"+
				"by the Free Software Foundation; either version 2 of the License,\n"+
				"or (at your option) any later version.\n\n"+

				"This program is distributed in the hope that it will be useful,\n"+
				"but WITHOUT ANY WARRANTY; without even the implied warranty of\n"+
				"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the\n"+
				"GNU General Public License for more details.\n\n"+

				"You should have received a copy of the GNU General Public License\n"+
				"along with this program; if not, write to the Free Software\n"+
				"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.\n\n" 
				;

		return about;
	}
	
	public static String getHelp() {
		String helpString="";
		helpString+= (  "OPTIONS:\n"
			+ "- [q/exit]"+ String.format("%38s","")+ "--- Exit program.\n"
			+ "- [h/help]"+ String.format("%38s","")+ "--- Get this help message.\n"
			+ "- [cl/clear]"+ String.format("%36s","")+ "--- Clear screen.\n"
			+ "- [o/open]"+ String.format("%5s","") + "+ <PATH>"+ String.format("%25s","")+ "--- Load Objectfile.\n"
			+ "- [l/list]"+ String.format("%5s","") + "+ <PATH>"+ String.format("%25s","")+ "--- List the sourcecode.\n"
			+ "- [br/break]"+ String.format("%36s","") + "--- Set breakpoint.\n"
			+ "- [del/delete]"+ String.format("%34s", "") + "--- Delete breakpoint.\n"
			+ "- [wp/watchpoint]"+ String.format("%31s","") + "--- Set watchpoint.\n"
			+ "- [r/run]"+ String.format("%39s","")+ "--- Run loaded Objectfile.\n"
			+ "- [s/step]"+ String.format("%38s","")+ "--- Executing one single instruction.\n"
			+ "- [reset]"+ String.format("%39s","")+ "--- Reset.\n"
			+ "- [i]"+ String.format("%43s","")+ "--- Interrupt. Type 'i' + <ENTER> while processor is running.\n"
			+ "- [get]"+ String.format("%41s","")+ "--- Show memory content.\n"
			+ "- [set]"+ String.format("%8s","") + "+ <address> <value>"+ String.format("%14s","")+ "--- Set memory content at a specified address.\n"
			+ "- [setr]"+ String.format("%7s","") + "+ <register> <value>"+ String.format("%13s","")+ "--- Set content of registers.\n"
			+ "- [i/info]"+ String.format("%5s","") + "+ <option>"+ String.format("%23s","")+ "--- Get Infos.\n"			
			+ "- [config]"+ String.format("%5s","") + "+ <var> + <value>"+ String.format("%16s","")+ "--- Setup new Configuration.\n"
			+ "- [d/disas]"+  String.format("%37s","")+ "--- Show disassembled code.\n"
			+ "- [vga]"+  String.format("%41s","")+ "--- Use VGA Plugin.\n"
			
			+ "\n===>    TYPE 'h/help + <command>' TO GET HELP FOR THE SPECIFIED COMMAND <command>\n"
		
			);
		return helpString;
	}
	//METHODEN FUER "help <command>" (hier: help br/break)
	public static String getHelpBreakpoint() {
		return "SET BREAKPOINT: (examples)\n" +
				"br/break 	     : show ALL set breakpoints\n" +
				"--------------------\n" +
				"br/break 12          : set breakpoint at address 12\n" +
				"br/break 0xff        : set breakpoint at address ff(=255)\n" +
				"br/break labelname   : set breakpoint at address of labelname\n"+
				"br/break labelname+3 : set breakpoint at address of labelname+3\n"+
				"br/break #5 	     : set breakpoint at line 5 of sourcecode, if already read in";
	}
	public static String getHelpWatchpoint() {
		return "SET BREAKPOINT: (examples)\n" +
				"wp/watchpoint 	     : show ALL set watchpoints\n" +
				"--------------------\n" +
				"wp/watchpoint 7/0x7  : set watchpoint at address 7\n";
				
	}
	public static String getHelpForDelete(){
		return "DELETE BREAKPOINT: (examples)\n" +
		"del/delete 	       : delete ALL breakpoints.\n" +
		"--------------------\n" +
		"del/delete 12          : delete breakpoint at address 12\n" +
		"del/delete 0xff        : delete breakpoint at address ff(=255)\n" +
		"del/delete labelname   : delete breakpoint at address of labelname\n"+
		"del/delete labelname+3 : delete breakpoint at address of labelname+3\n"+
		"del/delete #5 	       : delete breakpoint at line 5 of sourcecode, if already read in";				
    }
	public static String getHelpOpen() {
		return "OPEN - LOAD THE OBJECTFILE:\n" +
		"open + <path>        : loads the given objectfile\n";
	}
	public static String getHelpList() {
		return "LIST - SHOW THE SOURCEFILE: (examples)\n" +
		"list				  : While loading the objectfile, the sourcefile is read in too if their names are equal.\n"+
		"list + <path>	      		  : Else you will have to specify the path to the srcFile\n";
	}
	
	public static String getHelpGet() {
		return "GET MEMORY: (examples)\n" +
				"get 0/0x0            : get value at address 0\n" +
				"get 0/0x0 3/0x3      : get values between startAddress 0 and endAddress 3\n"+
				"get LABEL/+i         : get value at address of LABEL/+i\n";
	}
	
	public static String getHelpSet() {
		return "SET MEMORY: (examples)\n" +
				"set 0 2              : set value 2 at address 0\n" +
				"set 0xff 2/0x2       : set value 2 at address 0xff\n"+
				"set LABEL 2          : set value 2 at address of LABEL\n"+
				"set LABEL+3 2        : set value 2 at address of LABEL+3\n";
	}
	public static String getHelpSetR() {
		return "SETR: SET CONTENT OF REGISTERS: (examples)\n" + 
				"setr A 5/0x5	         : set content of A=5\n" +
				"setr R2(3) 5/0x5	 : set content of word 3 in R2 = 5\n"+
			"setr zero 1	         : set zero flag\n"+
		"setr carry 0	         : delete carry flag\n"+
		"setr ip 15/0xf	         : set instruction pointer = 15\n";
	}
	
	public static String getHelpInfo() {
		return "INFO: (examples)\n" +
				"i/info regs       	  : Show content of all registers\n" +
				"i/info ip       	  : Show current program counter\n" +
				"i/info labels             : Show all labels\n"+
				"i/info stats           	  : Show statistics (e.g. counters of instructions)\n"+				
				"i/info config       	  : Show processorconfiguration.\n" +
				"i/info about		  : Show about message\n";
	}
	public static String getHelpConfig() {
		return "SETUP NEW PROCESSOR CONFIGURATION: (examples/all options)\n" +
				"config				: Show processorconfiguration.\n" +
				"----------                             \n"+
				"config N 3           		: set amount of vectorregisters = 3\n" +
				"config K 10          		: set amount of words per vectorregister = 10 (has to be divisible by 2)\n" +
				"config use_scalar_mult 1   	: use scalar multiplication unit == TRUE (0 to set FALSE)\n" +
				"config use_vector_mult 1   	: use vector multiplication unit == TRUE (0 to set FALSE)\n" +				
				"config use_shuffle 1   		: use shuffle unit == TRUE (0 to set FALSE)\n" +
				"config shuffle_width 32   	: set max shuffle width = 32. (has to be divisible by 4)\n" +				
				"config use_vectorshift 1   	: use vetorshift unit == TRUE (0 to set FALSE)\n" +
				"config shift_width 32   	: set max vectorshift width = 32. \n" ;		
	}
	public static String getHelpReset() {
		return "RESET: \n" +
		"reset                   : Do all resets(FULL reset)\n"+
		"reset cpu               : Reset all registers, instructionpointer, and statistics.\n" +
		"reset mem/memory        : Reset memory. This also deletes all breakpoints.\n" ;
	}
	public static String getHelpVGA() {
		return "VGA - PLUGIN: \n" +
		"vga start          		:Start VGA.\n" +
		"vga stop          		:Stop VGA.\n";
	}
	
}
