------------------------------------------------------------------
-- PROJECT:     Der Hicovec Prozessor in Aktion
--
-- ENTITY:      LCD
--
-- PURPOSE:    LCDisplay Controller
-- 
-- System to
-- Connect,
-- Operate ,
-- Transfer data and
-- Compute with the
-- Hicovec 
--
-- Prof. Gundolf Kiefer
-- Hochschule Augsburg
--
-- TEAM:
--
-- Jakob Golus
-- David Lucinkiewicz
-- Andreas Mueller
-- Florian Richter	
-- Sebastian Rigorth
-- Soeren Ruehm
--
-- 
-- DATE CREATE: 2008-12-04
-- LAST CHANGE: 
-- VERSION:     0.1
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use work.cfg.all;

entity lcd is

	port (
		clk: std_logic;
		-- bus interface...
		adr: in std_logic_vector (31 downto 0);
		data: inout std_logic_vector (31 downto 0);
		adressed: out std_logic;
		rd, wr: in std_logic;
		ready: out std_logic;
		-- I/O ports...
		LCD_DB : out std_logic_vector(7 downto 0);
		LCD_E : out std_logic;
		LCD_RS : out std_logic;
		LCD_RW : out std_logic
	);
end lcd;

architecture RTL of lcd is
 
signal lcd_state: std_logic_vector (7 downto 0) := "00000000";

begin
	adressed <= '1' 
	when lcd_base_adr (31 downto 0) = adr (31 downto 0)
	else '0';
	
	lcd_db <= lcd_state;

	data <= "000000000000000000000000" & lcd_state
	when rd = '1'
	else "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
--test


--test
	process (clk)
	begin
		if clk'event and clk = '1' then
			ready <= '0';
			if rd = '1' then
				ready <= '1';
				LCD_RW <= '1';
			end if;
			if wr = '1' then
				lcd_state <= data(7 downto 0);
				LCD_E <= '1';
				LCD_RW <= '0';
				LCD_RS <= not data(8);
				ready <= '1';
			end if;
		end if;
	end process;
	
end RTL;

