%{
#include <stdio.h>
#include <stdlib.h>


%}

delim		[ \t]
Ziffer		[0-9]
Zahl		({Ziffer})*
Buchstabe	[a-zA-Z]
Register	reg[0-7]
regaxy		[AXY]
vregExp		R
Vregl		R{Zahl}
Byte		B
Word		W
DoubleWord	DW
QuadWord	QW
Comment		;.*
Label 		{Buchstabe}({Buchstabe}|{Ziffer})*
Merker		{Label}:
Alphavalue	'{Buchstabe}{1,2}'
HEX		0x({Ziffer}|[a-fA-F]){1,4}|$({Ziffer}|[a-fA-F]){1,4}



%option yylineno
%%
{Register}		{
		yylval.i = atoi(yytext);	
		 return(REGISTER);
		}

{regaxy}	{
		 if (yytext[0]== 'A')
			yylval.i = 1;		
		 else if (yytext[0]== 'X')
			yylval.i = 2;	
		 else if (yytext[0]== 'Y')
			yylval.i = 3;	
		 return(REGAXY);
		}
{Vregl}	{	yylval.i = atoi(yytext+1);
		if (yylval.i > 15)	
		{
			printf("lexical error:%i: only R0-R15 possible", yylineno);
			exit(1);
		}
		else
		{
			return(VREGL);
		}
		}

{vregExp}
		{
		return(VREGEXP);
		}
{Byte}		{
		 yylval.i = 0;
		 return(BYTE);
		}
{Word}		{
		 yylval.i = 1;
		 return(WORD);
		}
{DoubleWord}	{
		 yylval.i = 2;
		 return(DOUBLEWORD);
		}
{QuadWord}		{
		 yylval.i = 3;
		 return(QUADWORD);
		}


{Zahl}		{
		yylval.i = atoi(yytext);	
		 return(ZAHL);
		}

%%
