/*! commit.h
 *  In this file the types are defined which are used in Parser.y and Scanner.l
 *
 *  @author Eggenmueller Bernd
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
#ifndef COMMITH
#define COMMITH
#define TEXT_LENGTH 43	// Eine Zeile bei der VGA-Ausgabe + beide Anfhrungszeichen


#define false 0
#define true 1



//for labels 
typedef struct 
{
	int line;
	char mark[TEXT_LENGTH];
}MARK;
/* Diese Struktur enthält die Permutationsparameter der Shuffleoperation
*/
typedef struct 
{
	int p;		// Permutationsalgorithmus 8 Bit 
	int b;		// Wortbreite 2 Bit
	int s;		// Quelle/Registerauswahl von w und v 4 Bit
	char permutation[14];
}PERMUTATION;



typedef struct 
{
	struct commentl *commentl;
	int line;
}ENDV;

typedef struct commentl
{
	char *comment;
	int line;
	struct commentl *next;
}COMMENTLIST;

//datatypes for .o-file

//type for the MERKERLIST
typedef struct merkerl 
{
	int length;			//length of the MERKER
	char name[TEXT_LENGTH];	//name of the MERKER
	int adress;
	struct merkerl *next;	
}MERKERLIST;

typedef struct codel
{
	int startAdress;
	int length;
	struct codel *next;
}CODELIST;

typedef struct adress
{	
	int line;
	int wortAnz; 
	unsigned int code;
	int flag; 		/* 	flag: Falls eine Expression existiert, gibt diese Flag an wo sie nach der Berechnung abgespeichert werden soll
					flag == 0: keine Expression vorhanden
					flag == 1: mehrere Expressions können vorkommen, in form einer Liste (BSP: DC 4+5,3+4 entspricht zwei Expressions)
					flag == 2: eine Expression kommt vor
					
				*/
	int isSkalar,isVektor;	// Gibt an ob es sich um einen Skalar oder Vektorbefehl handelt
	struct wertRet *expr;	// Achtung Zeiger vom Typ wertRet NICHT vom Typ expression
}COMMAND_RETURN;

enum operations{E_VAL=0,E_LAB,E_ADDOP,E_SUBOP,E_MULOP,E_DIVOP,E_BITSHIFT_L,E_BITSHIFT_R,E_ANDOP,E_OROP,E_CLAMP,E_NOTOP};

typedef struct exprRet
{
	int value;
	enum operations operation;
	char label[TEXT_LENGTH];
	struct exprRet *left;
	struct exprRet *right;
}EXPRESSION_RETURN;

typedef struct wertRet
{
	//analog zu flag bei COMMAND_RETURN
	int load;
	//memory-adress
	int memory;
	EXPRESSION_RETURN *expression;
	
	struct wertRet *next;
}WERT_RETURN;

//datatypes for Tokens
typedef struct
{
	int line;
	int value;
	_Bool regex; // true when reg and false if expr.
	WERT_RETURN *wertret;
}VALUE;

//datatypes for Tokenstrings...
typedef struct 
{
	int line;
	char string[TEXT_LENGTH];
	WERT_RETURN *wertret;
}STRINGS;

#endif
