/*! errOut.c
 *  In this file are the whole errors of the Compiler which could print out
 *
 *  @author Eggenmueller Bernd , Juergen Schmidt
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
#include <stdio.h>
#include <stdlib.h>
#include "config.h"

Err_NoCode()
{	printf("Error: No Code\n");
	exit(1);
}

Err_syntax(char* msg,int lineno,char* text)
{	printf("%s: line %d near: %s \n", msg, lineno, text);
}

Err_DestFile()
{	printf("Error: destination file must end with %s\n",DESTINATION_FILE_END);
	exit(2);
}

Err_SrcFile()
{	printf("Error: source file must end with %s\n",SOURCE_FILE_END);
	exit(3);
}

Err_UnknownOption(char opt)
{
	//gives out the wrong option of the programm call
	if (isprint(opt))	printf ("Error: Unknown option `-%c'.\n", opt);
	else 	printf ("Error: Unknown option character `\\x%x'.\n",opt);
	exit(4);
}

Err_Out()
{
	printf("Error: Unknown error!\n");
	exit(5);
}

Err_ReadSrc(char* file)
{	printf("Error: Can`t read sourcefile: %s\n",file);
	exit(6);
}

Err_NoSrc()
{
	printf("Error: No sourcefile\n");
	exit(7);
}

Err_TooMuchSourceFiles(int begin,int end,char **files)
{	int nu;	
	printf("Error: Too much sourcefiles: ");
	//give out the whole file-names from the programm call
	for (nu=begin; nu<end; nu++)
		printf ("%s, ", files[nu]);
	printf("\n");
	exit(8);
}

Err_TooMochStart(int anz)
{	printf("Error: too many .start declered (%d)\n",anz);
	exit(9);
}

Err_NoSuchSec(int section_number)
{	printf("Error: No such section (%d)\n", section_number);
	exit(10);
}

Err_LabelNotExist(char* label_name)
{	printf("Label doesn't exist: %s\n", label_name);
	exit(11);
}
Err_ParallelFailure(int line)
{
	printf("%i: Error: Only a scalar- and a vectorcommand can be executed parallel. Check this line and compare with the instructionslist!");
}
