/*! functions.h
 *  In this file the functions are defined to parse the input und create the output file
 *
 *  @author Eggenmueller Bernd
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
#include <stdio.h>
#include "commit.h"

//lists.c
MERKERLIST* add_Merker_To_List(MERKERLIST *first, char *name, int adress);
void adressToLine(int actuellLine, short int *lineArray, int *lineInd, int aktuellAdress);
CODELIST* addToCodelist(int startAdress,CODELIST *codelist,int lastAdress);

//wertReturn.c
WERT_RETURN* codeAndExpr(COMMAND_RETURN *command,WERT_RETURN *firstExpr, int memInd, unsigned int *mem);

//debug.c
void printMerker(MERKERLIST *first);
void printCode(CODELIST *first);
void printMemory(CODELIST *first,unsigned int *memory);
void printLines(int index, short int *lines);
void printExpressions(WERT_RETURN *firstExpr);
void printComments(COMMENTLIST *first);
void printSectionTab(int *secArray,int secAnz);

//expression.c
void calculateExpressions(WERT_RETURN *firstExpr,unsigned int *memory,MERKERLIST *first_Merker);
int calculate(EXPRESSION_RETURN *expr, MERKERLIST *first);

//writeInFile.c
void writeString(FILE **file, char *str);
void fwriteIntBigEndian(int value,FILE **file);

//createFile.c
void createSectionTab(FILE **fp,int *wCount,int *secArray, int secAnz);
void createSections(FILE **fp,int *secArray,int secAnz,MERKERLIST *firstMerker,int lineInd,short int *lineTab,COMMENTLIST *commentl,char *info,CODELIST *firstCode,unsigned int *memory, int start);
void writeRegisterSection(FILE **fp, int start, short int *lineTab);
void writeInfoSection(FILE **fp,char *info);
void writeCommentSection(FILE **fp,COMMENTLIST *commentl);
void writeLabelSection(FILE **fp,MERKERLIST *firstMerker);
void writeLineSection(FILE **fp, int lineInd, short int *lineTab);
void writeCodeSection(FILE **fp,CODELIST *firstCode,CODELIST *helpC,unsigned int *memory);
void createHeader(FILE **fp,int magic_number);

//makeObjectFile.c
void makeObjectDat(MERKERLIST *firstMerker, int lineInd, short int *lineTab, COMMENTLIST *commentl, CODELIST *firstCode, unsigned int *memory,int start, char *datName, int inhalt);

//error.c
int errorMemoryCheck(CODELIST *first);
int errorMainCheck(int start, int noStart);

//parseFunctions.c
EXPRESSION_RETURN* newExpression(enum operations operation,int value,char *merker,EXPRESSION_RETURN *left,EXPRESSION_RETURN *right);
COMMAND_RETURN newCommand_Reg(int line,int cmd_5bit,int reg1_3bit, int reg2_3bit, int reg3_3bit,int last2bit,WERT_RETURN *wert,int wortAnz,int low8);
COMMAND_RETURN newCommand(int line,unsigned int code_16bit,WERT_RETURN *wert,int wortAnz,int low8, int Skalar, int Vektor);
COMMAND_RETURN newCommand_LDI(int line,int cmd_5bit,int reg_3bit, int value_8bit,WERT_RETURN *wert,int wortAnz,int low8);
COMMAND_RETURN uniteCommands(COMMAND_RETURN *cmdRet1, COMMAND_RETURN *cmdRet2);
COMMAND_RETURN NewCommand_ScalarAndReg(int line,int cmd_6bit,int reg1_2bit, int reg2_2bit,int reg3_2bit,WERT_RETURN *wert,int wortAnz, int low8);
COMMAND_RETURN NewCommand_VectorAndReg(int line,int cmd_8bit,  int reg1_4bit,int reg2_4bit,int reg3_4bit,WERT_RETURN *wert,int wortAnz, int low8);
COMMAND_RETURN NewCommand_ScalarRegDirectValue(int line,int cmd_6bit,int reg1_2bit,int reg2_2bit,int direct_value, WERT_RETURN *wert, int wortAnz,int low8);
COMMAND_RETURN NewCommand_MoveCmds(int line, int scCmd_6bit,int scReg1_2bit,int scReg2_2bit,int scReg3_2bit, int veCMD_8bit,int veReg1_4Bit, int veReg2_4Bit, WERT_RETURN *wert, int wortAnz, int low8);
COMMAND_RETURN NewCommand_VectorRegDirectValue(int line, int cmd_8bit,int reg1_4bit,int reg2_4bit,int direct_value, WERT_RETURN *wert, int wortAnz, int low8);
COMMAND_RETURN NewCommand_VectorAlu(int line, int width, int cmd_4bit, int reg1_4bit, int reg2_4bit,int reg3_4bit, WERT_RETURN *wert,  int wortAnz,int low8);
COMMAND_RETURN NewCommand_shuffle(int line, int width,int regA_4bit,int reg1_4bit,int reg2_4bit,int reg3_4bit, int permutation,WERT_RETURN *wert, int wortAnz, int low8);
void convertToPerm(PERMUTATION* permut);
