/*
*  Filename: chipdebuglib.h
*  Author: Michael Schaeferling
*  Institute: Hochschule Augsburg, Fakultaet fuer Informatik
*  Date of last change: 09-03-12
*  About: This file is part of the OnChipDebugger (via RS232).
*         This library needs to be used when interfacing the serial debugging hardware.
*  Version: 0.50
*/


#ifndef _CHIPDEBUGLIB_
#define _CHIPDEBUGLIB_


#define IOSTREAM "/dev/ttyS1"


int SetVerbosity(int verb);
int GetVerbosity();

int Open (char *c_port);
void Close ();

int WriteChain(int chainID, char* c_to_chip);
int ReadChain(int chainID, char* c_from_chip);
/*
int SetPin(int chainID, int chainLength, int pin, int value);
int GetPin(int chainID, int chainLength, int pin);
*/

int Step(int stepCount, unsigned char chainMask);

int Run(unsigned char chainMask);
int Stop();

int IsAlive();

#ifdef SWIG
%module chipdebug
#endif

#endif /* _CHIPDEBUGLIB_ */

