#!/usr/bin/python
# This file is part of the SCOTCH project
# This Programm convert a max (320 * 200) Picuture to a VHDL Dump to use it in the VODCA RAM
# (C) 2007-2008 David Lucinkiewicz Fachhochschule Augsburg, University of Applied Sciences

from string import *
from sys import *
import array
import os
import cmd



version="1.0"



def toBinary (val, len):
  return "".join(map(lambda y:str((val >> y) & 1), range(len-1, -1, -1)))


def fromBinary (x):
  return sum(map(lambda z: int(x[z]) and 2**(len(x) - z - 1), range(len(x)-1, -1, -1)))


def toInt (s):
  if s[0:2] == "0x": return int(s[2:], 16);
  else: return int(s);





################### (Object) file I/O #####################


def readObjAndSrcFile (objFileName):
  "returns (memory, comments), both as dictionaries by adress"
  
  # Read the object file...
  f = open (objFileName, "rb")
  objData = array.array('H')
  try: objData.fromfile (f, 999999)
  except EOFError: pass
  print "Read object file '%s'." % objFileName

  
  # Convert to little endian...
  for n, v in enumerate (objData):
    objData[n] = ((v & 0xff) << 8) | (v >> 8)
    #print "%5i. %04x" % (n, v)  
  
  #print "%04x" % objData[0]
  #print "%04x" % objData[1]
  #print "%04x" % objData[2]
  # Init 'outMemory' and 'outComments'...
  outMemory = {}
  outComments = {}
  
  # Parse header...
  magnum = objData[0]
  #print "Magic Number: %04x" % magnum;
  if magnum != 0x424D: raise Exception, "Wrong magic number - not a bmp file?"
  #getting amount of sections
  print "******************* Bild - Informationen ***********************************"
  groesse = objData[1]
  groesse = groesse << 16
  groesse += objData[2]
  groesse = change_HL(groesse)
  print "Dateigroesse = %04x(hex) = %i(dec) Byte" % (groesse, groesse)

  code_start = objData[5]
  code_start = code_start << 16
  code_start += objData[6]
  code_start = change_HL(code_start)
  print "Code_start = %04x(hex) = %i(dec)" % (code_start, code_start)
  print "1ter Pixel des Bildes: %04x(hex)" % objData[code_start/2]
  
  b_breit = objData[9]
  b_breit = b_breit << 16
  b_breit += objData[10]
  b_breit = change_HL(b_breit)

  b_hoch = objData[11]
  b_hoch = b_hoch << 16
  b_hoch += objData[12]
  b_hoch = change_HL(b_hoch)

  print "Bild Hoch: %i, Bild Breit: %i" % (b_breit, b_hoch)


  
  print "******************* Bild - Informationen ***********************************"
  z = 0
  for i in range(0,groesse,2):
   outMemory[i]   = objData[z] >> 8
   outMemory[i+1] = objData[z] & 0x000000FF
   #print "Index: %i, %02x" % (i, outMemory[i])
   z = z+1
   
   
  

  
  
  return (outMemory, outComments,code_start,groesse)
  

def change_HL (temp):
 temp1 = temp >> 8
 temp1 = temp1 & 0x000000FF
 temp2 = temp << 8 
 temp2 = temp2 & 0x000000FF00
 temp3 = temp1 | temp2
 temp0 = temp >> 16
 temp1 = temp0 >> 8
 temp1 = temp1 & 0x000000FF
 temp2 = temp0 << 8 
 temp2 = temp2 & 0x000000FF00
 temp4 = temp1 | temp2
 temp = temp3 << 16
 temp = temp | temp4
 return temp

def wandle(val):
 zahl1 = val >> 4
 zahl1 = zahl1 & 0x0000000F 
 zahl2 = val & 0x0000000F
 zahl1 = wandlezahl(zahl1)
 zahl2 = wandlezahl(zahl2) 
 string1 = str(zahl1)
 string2 = str(zahl2)
 if string1 == '10': string1 = 'A'
 if string1 == '11': string1 = 'B'
 if string1 == '12': string1 = 'C'
 if string1 == '13': string1 = 'D'
 if string1 == '14': string1 = 'E'
 if string1 == '15': string1 = 'F'
 
 if string2 == '10': string2 = 'A'
 if string2 == '11': string2 = 'B'
 if string2 == '12': string2 = 'C'
 if string2 == '13': string2 = 'D'
 if string2 == '14': string2 = 'E'
 if string2 == '15': string2 = 'F'
 
 string0 = string2 + string1
 return string0

def wandlezahl(zahl):
 if   zahl == 0x0: return 0xF
 elif zahl == 0x1: return 0xE
 elif zahl == 0x2: return 0xD
 elif zahl == 0x3: return 0xC
 elif zahl == 0x4: return 0xB
 elif zahl == 0x5: return 0xA
 elif zahl == 0x6: return 0x9
 elif zahl == 0x7: return 0x8
 elif zahl == 0x8: return 0x7
 elif zahl == 0x9: return 0x6
 elif zahl == 0xA: return 0x5
 elif zahl == 0xB: return 0x4
 elif zahl == 0xC: return 0x3
 elif zahl == 0xD: return 0x2
 elif zahl == 0xE: return 0x1
 elif zahl == 0xF: return 0x0

 

 
 


def printVhdl (memory, comments, code_start, code_end):
  if len(memory) == 0:
    print "BMP not loaded!"
    return;

  # Add dummy memory entries for commented but undefined memory adresses...
  for adr in comments.iterkeys():
    if not adr in memory: memory[adr] = -1
  
  # Output VHDL...
  adrList = memory.keys ()
  adrList.sort()
  print "  -- Memory content (created by BMPtoSCOTCH) ..."
  #print "  type t_memory is array (%i to %i) of STD_LOGIC_VECTOR(31 downto 0);" % (adrList[0], adrList[-1])
  #print "  signal mem_content: t_memory := ("
   
  s_puffer = ''
  programm =''
  puffer = ''
  j = 0x0
  i = 0

  datei="ausgabe.txt"
  out_file = open(datei,"w")
    
  for adr in xrange(code_end-159, code_start, -161):
  
    for a in range(0,159,1): 
     #print "adr: %x mem(adr): %x" % (adr, memory[adr])
     puffer = wandle(memory[adr+a]) +puffer
     i = i+1 
     if i==4:
      out_file.write("  16#%04x# => X\"%s\",\n" % (j, puffer))
      #print "  16#%04x# => X\"%s\"," % (j, puffer)
      puffer = ''
      i=0    
      j= j+1  
  
  

  #print "  others => \"UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU\""
  #print "  );"

  out_file.close()




################### Command interpreter ###################


class MyCmd(cmd.Cmd):

  def __init__(self):
    cmd.Cmd.__init__(self)
    self.prompt = "(convert) "
    self.intro = ""
    self.memory = {}
    self.comments = {}
    self.code_start = 0
    self.code_end = 0
 

  # Helpers...
  def completeFileName(self, text, line, begidx, endidx):
    name = text
    if line[-1] == ' ': dir = ""
    else: dir = line.rsplit(" ", 1) [-1]
    if len(name) > 0: dir = dir[:-len(name)]
    if dir == "": dir = "."
    #print [ text, line, begidx, endidx, dir, name ]
    ret = []
    try:
      textlen = len(text)
      for f in os.listdir(dir) + [ ".", ".." ]:
        if f[:textlen] == text:
          if os.access (dir + "/" + f + "/", os.F_OK): ret += [ f + "/" ]
          else: ret += [ f + " " ]
    except: pass
    return ret

  def error(self, msg):
    print "*** %s" % msg
    #self.do_help(self.lastcmd);

  # Overloaded pre-defined methods...
  def completenames(self, text, line, begidx, endidx):
    l = cmd.Cmd.completenames(self, text, line, begidx, endidx)
    #print l, begidx, endidx, "EOF"[endidx:]
    try: l.remove("EOF")
    except: pass
    return [x + " " for x in l]

  def onecmd(self, str):
    try:
      return cmd.Cmd.onecmd(self, str)
    except KeyboardInterrupt:
      boardRecover()
      print "\nStopped"
    except Exception, msg:
      self.error(msg)
      return False

  def do_help(self, arg):
    print
    if arg: cmd.Cmd.do_help(self, arg)
    else:
      for x in dir(self):
        if x[:5] == "help_": exec ("self." + x + "()")
    print

  # Command: Exit ...
  def do_exit(self, arg):
    return True
  def help_exit(self):
    print "exit              - exit the tool"
  def do_EOF(self, arg):
    print
    return self.do_exit(arg)

  # Command: Open...
  def do_open(self, arg):
    (self.memory, self.comments, self.code_start, self.code_end) = readObjAndSrcFile (arg)
  def help_open(self):
    print "open <file name>  - open an bmp file"
  def complete_open(self, text, line, begidx, endidx):
    #print "complete_open"
    return self.completeFileName (text, line, begidx, endidx)

  # Command: VHDL dump...
  def do_dump(self, arg):
    printVhdl(self.memory, self.comments, self.code_start, self.code_end)
  def help_dump(self):
    print "dump              - dump the memory contents (VHDL syntax)"



################### Main ##################################


def usage ():
  print ("Usage: convert [options]\n"
         "\nOptions:\n"
         "  -h              : this help\n"
         "  -d <device>     : set serial device (default: " + optSerialDevice + ")\n"
         "  -c <command(s)> : execute commands upon startup\n")
  exit ()


from getopt import *


print "BMP to SCOTCH", version, "\n\n(C) 2008 - 2009\n","David Lucinkiewicz\n","University of Applied Sciences Augsburg\n"


# Read options...
firstCmds = []
try:
  opts, args = getopt (argv[1:], "hd:c:")
  for opt, value in opts:
    if opt == "-d": optSerialDevice = value;
    elif opt == "-c": firstCmds = value.split(";")
    #elif opt == "-h":
    else: usage ()
except GetoptError:
  usage ()

# instances prompt environment
myCmd = MyCmd()
noExit = True

# Run first commands...
for c in firstCmds:
  try:
    print myCmd.prompt + c.strip()
    noExit = not myCmd.onecmd (c)
    if not noExit: break
  except Exception:
    break

# Re-run the main command loop as long it has been ended by an exception (e.g. KeyboardInterrupt, Ctrl-C)
while noExit:
  try:
    myCmd.cmdloop()
    noExit = False
  except KeyboardInterrupt:
    print


raw_input



